#pragma once
#define PARM_ALLOC_STEP 100
#define DATA_ALLOC_STEP 1000

#define FIT_FINISH 0
#define FIT_STOP 1
#define FIT_ABNORMAL 2

class __declspec(dllexport) Cfit
{
public:
	Cfit();
	~Cfit();
public:
	char Name[256];
	virtual char *FuncType() = 0;
	virtual char *FuncHelp() = 0;
	double Func_i(double x, int i);	
	virtual double Func(double x);
	double Error();
	void DError();
	void SaveParm();
	void LoadParm();
	int CGFit();
	void SetCGParm(double dt, double tol);
	void GetCGParm(double *dt, double *tol);
	int SAFit();
	void SetSAParm(double maxvar, double temp, int tstep, int cstep);
	void GetSAParm(double *maxvar, double *temp, int *tstep, int *cstep);
	double Correlation();
	int GetnExp();
	int GetnParm();
	void ClearParm();
	BOOL AddParm(double value, BOOL fix);
	void GetParm(int i, int j, double *value, double *dvalue, BOOL *fix);
	void UpdateParm(int i, int j, double value, BOOL fix);
	int GetnData();
	void ClearData();
	BOOL AddData(double x, double y);
	BOOL AddData(double x, double y, double ymin, double ymax);
	void GetData(int i, double *x, double *y);
	void GetData(int i, double *x, double *y, double *ymin, double *ymax);
	int GetCount();
	void SetStop();
	CRITICAL_SECTION critSec;
protected:
	int nParm;
	virtual double Func_i(double x, int i, double parm1[]) = 0;
	virtual void DFunc_i(double x, int i, double parm1[], double dfunc1[]) = 0;
	virtual void DFunc(double x, double dfunc[]);
	virtual void Limit_i(double parm1[]) = 0;
	virtual void Limit();
private:
	int nExp;
	double *Parm;
	double *dParm;
	BOOL *fixParm;
	int totnParm;
	int totnParmMax;
	double *startParm;
	double *savedParm;
	int nData;
	int nDataMax;
	double *xData;
	double *yData;
	double *yDataMin;
	double *yDataMax;
	long Count;
	BOOL stopFlag;	
	double cgDt;
	double cgTol;
	double saMaxVar;
	double saTemp;
	int saTotalStep;
	int saCoolingStep;
	void SetLineStart();
	double LineError(double dt);
	void Section(double dt[], double e[]);
	double Golden(double dt1, double dt2, double tol);
	double LineMinimize(double dt, double tol);
};
