// user.cpp : DLL AvP[VpɃGNX|[g֐`܂B
//

#include "stdafx.h"
#include "user.h"
#include <math.h>

#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif

Cuser::Cuser()
{
	// number of parameter in formula
	nParm = 3;
}

Cuser::~Cuser()
{
}

char *Cuser::FuncType()
{
	return "User";
}

char *Cuser::FuncHelp()
{
	return "Formula : Sum(i=0,N-1) f_i/(sqrt(2*PI)*sig_i)*exp(-(x-mu_i)^2/(2*sig_i^2))\r\nParameters : f_i(>=0), mu_i, sig_i\r\n";
}

double Cuser::Func_i(double x, int i, double parm1[])
{
	double f = parm1[0];
	double mu = parm1[1];
	double sig = parm1[2];
	return f/(sqrt(2.0*M_PI)*sig)*exp(-pow(x-mu,2.0)/2.0/sig/sig);
}

void Cuser::DFunc_i(double x, int i, double parm1[], double dfunc1[])
{
	double f = parm1[0];
	double mu = parm1[1];
	double sig = parm1[2];
	dfunc1[0] = 1.0/(sqrt(2.0*M_PI)*sig)*exp(-pow(x-mu,2.0)/2.0/sig/sig);
	dfunc1[1] = f*dfunc1[0]*(x-mu)/sig/sig;
	dfunc1[2] = f*dfunc1[0]*(pow(x-mu,2.0)/pow(sig,3.0)-1.0/sig);
}

void Cuser::Limit_i(double parm1[])
{
	if (parm1[0] < 0.0) parm1[0] = 0.0;
}

extern "C" __declspec(dllexport) Cfit *CVFIT_CreateFit()
{
	return new Cuser;
}
